]> arthur.barton.de Git - bup.git/blobdiff - t/subtree-hash
subtree-hash: accommodate python 3
[bup.git] / t / subtree-hash
index 94cd3b36d1f7e77c59a57fd344dbd1fd79132b53..1ca9e869c84a0dab1e5ce1ee647cb391170b9947 100755 (executable)
@@ -1,29 +1,49 @@
-#!/usr/bin/env python
+#!/bin/sh
+"""": # -*-python-*-
+bup_python="$(dirname "$0")/../cmd/bup-python" || exit $?
+exec "$bup_python" "$0" ${1+"$@"}
+"""
+# end of bup preamble
 
-from subprocess import check_output
-import argparse
+from __future__ import absolute_import, print_function
 import sys
 
-parser = argparse.ArgumentParser()
-parser.add_argument("ROOT_HASH", help="root tree for the search")
-parser.add_argument("PATH_ITEM", help="path component", nargs='*')
-opts = parser.parse_args()
-tree_hash = opts.ROOT_HASH
-path = opts.PATH_ITEM
+from bup.compat import argv_bytes
+from bup.helpers import handle_ctrl_c, readpipe
+from bup.io import byte_stream
+from bup import options
+
+
+optspec = """
+subtree-hash ROOT_HASH [PATH_ITEM...]
+--
+"""
+
+handle_ctrl_c()
+
+o = options.Options(optspec)
+(opt, flags, extra) = o.parse(sys.argv[1:])
+
+if len(extra) < 1:
+    o.fatal('must specify a root hash')
+
+tree_hash = argv_bytes(extra[0])
+path = [argv_bytes(x) for x in extra[1:]]
 
 while path:
     target_name = path[0]
-    subtree_items = check_output(['git', 'ls-tree', '-z', tree_hash])
+    subtree_items = readpipe([b'git', b'ls-tree', b'-z', tree_hash])
     target_hash = None
-    for entry in subtree_items.split('\0'):
+    for entry in subtree_items.split(b'\0'):
         if not entry:
             break
-        info, name = entry.split('\t', 1)
+        info, name = entry.split(b'\t', 1)
         if name == target_name:
-            _, _, target_hash = info.split(' ')
+            _, _, target_hash = info.split(b' ')
             break
     if not target_hash:
-        print >> sys.stderr, "Can't find %r in %s" % (target_name, tree_hash)
+        print("Can't find %r in %s" % (target_name, tree_hash.decode('ascii')),
+              file=sys.stderr)
         break
     tree_hash = target_hash
     path = path[1:]
@@ -31,4 +51,6 @@ while path:
 if path:
     sys.exit(1)
 
-print tree_hash
+sys.stdout.flush()
+out = byte_stream(sys.stdout)
+out.write(tree_hash + b'\n')